Bug 201810 - lockdep: circular locking dependency detected from beagled (dev->ev_mutex)
lockdep: circular locking dependency detected from beagled (dev->ev_mutex)
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
rawhide
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Peter Zijlstra
Brian Brock
:
Depends On:
Blocks: FCMETA_LOCKDEP
  Show dependency treegraph
 
Reported: 2006-08-08 20:09 EDT by Kenneth Topp
Modified: 2014-08-11 01:40 EDT (History)
3 users (show)

See Also:
Fixed In Version: fc6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-10-29 01:31:11 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Kenneth Topp 2006-08-08 20:09:01 EDT
Description of problem:

with kernel-2.6.17-1.2530.fc6

Aug  8 12:20:09 static kernel:
=======================================================
Aug  8 12:20:09 static kernel: [ INFO: possible circular locking dependency
detected ]
Aug  8 12:20:09 static kernel:
-------------------------------------------------------
Aug  8 12:20:09 static kernel: beagled/3343 is trying to acquire lock:
Aug  8 12:20:09 static kernel:  (&mm->mmap_sem){----}, at: [<c0610735>]
do_page_fault+0x174/0x4a4
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: but task is already holding lock:
Aug  8 12:20:09 static kernel:  (&dev->ev_mutex){--..}, at: [<c060e3b0>]
mutex_lock+0x21/0x24
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: which lock already depends on the new lock.
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: the existing dependency chain (in reverse order) is:
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: -> #3 (&dev->ev_mutex){--..}:
Aug  8 12:20:09 static kernel:        [<c043bfc5>] lock_acquire+0x4b/0x6a
Aug  8 12:20:09 static kernel:        [<c060e241>] __mutex_lock_slowpath+0xbc/0x20a
Aug  8 12:20:09 static kernel:        [<c060e3b0>] mutex_lock+0x21/0x24
Aug  8 12:20:09 static kernel:        [<c0497312>]
inotify_dev_queue_event+0x1f/0x108
Aug  8 12:20:09 static kernel:        [<c049692b>]
inotify_remove_watch_locked+0x27/0x31
Aug  8 12:20:09 static kernel:        [<c0496bc6>] inotify_rm_wd+0x75/0x93
Aug  8 12:20:09 static kernel:        [<c0496ffe>] sys_inotify_rm_watch+0x40/0x58
Aug  8 12:20:09 static kernel:        [<c0403faf>] syscall_call+0x7/0xb
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: -> #2 (&ih->mutex){--..}:
Aug  8 12:20:09 static kernel:        [<c043bfc5>] lock_acquire+0x4b/0x6a
Aug  8 12:20:09 static kernel:        [<c060e241>] __mutex_lock_slowpath+0xbc/0x20a
Aug  8 12:20:09 static kernel:        [<c060e3b0>] mutex_lock+0x21/0x24
Aug  8 12:20:09 static kernel:        [<c04965c8>]
inotify_find_update_watch+0x42/0x83
Aug  8 12:20:09 static kernel:        [<c049763e>] sys_inotify_add_watch+0xb0/0x14e
Aug  8 12:20:09 static kernel:        [<c0403faf>] syscall_call+0x7/0xb
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: -> #1 (&inode->inotify_mutex){--..}:
Aug  8 12:20:09 static kernel:        [<c043bfc5>] lock_acquire+0x4b/0x6a
Aug  8 12:20:09 static kernel:        [<c060e241>] __mutex_lock_slowpath+0xbc/0x20a
Aug  8 12:20:09 static kernel:        [<c060e3b0>] mutex_lock+0x21/0x24
Aug  8 12:20:09 static kernel:        [<c049688f>]
inotify_inode_queue_event+0x32/0xa7
Aug  8 12:20:09 static kernel:        [<c0496d44>]
inotify_dentry_parent_queue_event+0x69/0x83
Aug  8 12:20:09 static kernel:        [<c0473b4d>] __fput+0x70/0x17b
Aug  8 12:20:09 static kernel:        [<c0473c6f>] fput+0x17/0x19
Aug  8 12:20:09 static kernel:        [<c0463515>] remove_vma+0x3c/0x4e
Aug  8 12:20:09 static kernel:        [<c0463e5a>] do_munmap+0x18c/0x1a6
Aug  8 12:20:09 static kernel:        [<c0463ea7>] sys_munmap+0x33/0x42
Aug  8 12:20:09 static kernel:        [<c0403faf>] syscall_call+0x7/0xb
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: -> #0 (&mm->mmap_sem){----}:
Aug  8 12:20:09 static kernel:        [<c043bfc5>] lock_acquire+0x4b/0x6a
Aug  8 12:20:09 static kernel:        [<c043901c>] down_read+0x2d/0x40
Aug  8 12:20:09 static kernel:        [<c0610735>] do_page_fault+0x174/0x4a4
Aug  8 12:20:09 static kernel:        [<c0404be1>] error_code+0x39/0x40
Aug  8 12:20:09 static kernel:        [<c04eaffb>] copy_to_user+0x4e/0x57
Aug  8 12:20:09 static kernel:        [<c049728c>] inotify_read+0xf5/0x15c
Aug  8 12:20:09 static kernel:        [<c047334c>] vfs_read+0xa9/0x155
Aug  8 12:20:09 static kernel:        [<c04737dc>] sys_read+0x3b/0x60
Aug  8 12:20:09 static kernel:        [<c0403faf>] syscall_call+0x7/0xb
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: other info that might help us debug this:
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: 1 lock held by beagled/3343:
Aug  8 12:20:09 static kernel:  #0:  (&dev->ev_mutex){--..}, at: [<c060e3b0>]
mutex_lock+0x21/0x24
Aug  8 12:20:09 static kernel: 
Aug  8 12:20:09 static kernel: stack backtrace:
Aug  8 12:20:09 static kernel:  [<c04051ee>] show_trace_log_lvl+0x58/0x159
Aug  8 12:20:09 static kernel:  [<c04057ea>] show_trace+0xd/0x10
Aug  8 12:20:09 static kernel:  [<c0405903>] dump_stack+0x19/0x1b
Aug  8 12:20:09 static kernel:  [<c043b0b2>] print_circular_bug_tail+0x59/0x64
Aug  8 12:20:09 static kernel:  [<c043b8c5>] __lock_acquire+0x808/0x997
Aug  8 12:20:09 static kernel:  [<c043bfc5>] lock_acquire+0x4b/0x6a
Aug  8 12:20:09 static kernel:  [<c043901c>] down_read+0x2d/0x40
Aug  8 12:20:09 static kernel:  [<c0610735>] do_page_fault+0x174/0x4a4
Aug  8 12:20:09 static kernel:  [<c0404be1>] error_code+0x39/0x40
Aug  8 12:20:09 static kernel: DWARF2 unwinder stuck at error_code+0x39/0x40
Aug  8 12:20:09 static kernel: Leftover inexact backtrace:
Aug  8 12:20:09 static kernel:  [<c04057ea>] show_trace+0xd/0x10
Aug  8 12:20:09 static kernel:  [<c0405903>] dump_stack+0x19/0x1b
Aug  8 12:20:09 static kernel:  [<c043b0b2>] print_circular_bug_tail+0x59/0x64
Aug  8 12:20:09 static kernel:  [<c043b8c5>] __lock_acquire+0x808/0x997
Aug  8 12:20:09 static kernel:  [<c043bfc5>] lock_acquire+0x4b/0x6a
Aug  8 12:20:09 static kernel:  [<c043901c>] down_read+0x2d/0x40
Aug  8 12:20:09 static kernel:  [<c0610735>] do_page_fault+0x174/0x4a4
Aug  8 12:20:09 static kernel:  [<c0404be1>] error_code+0x39/0x40
Aug  8 12:20:09 static kernel:  [<c04eaffb>] copy_to_user+0x4e/0x57
Aug  8 12:20:09 static kernel:  [<c049728c>] inotify_read+0xf5/0x15c
Aug  8 12:20:09 static kernel:  [<c047334c>] vfs_read+0xa9/0x155
Aug  8 12:20:09 static kernel:  [<c04737dc>] sys_read+0x3b/0x60
Aug  8 12:20:09 static kernel:  [<c0403faf>] syscall_call+0x7/0xb
Comment 1 Peter Zijlstra 2006-09-25 13:06:30 EDT
Kenneth, can you still reproduce this warning? I'm a bit stumped by this trace,
and am wondering if the latest kernel 1) still triggers it, and 2) gives the
exact same trace.

Comment 2 Kenneth Topp 2006-10-28 19:02:39 EDT
No, issue went away with more recent kernels.

Note You need to log in before you can comment on or make changes to this bug.